#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int sum=0;
    vector<int> c(n);

    for(int i=0; i<n; i++)
    {
        cin >> c[i];
        sum+=c[i];
    }
    sum/=3;
    int x=0, y=0, z=0, s1=0;
    for(int i=0; i<n; i++)
    {
        if(s1<sum)
        {
            s1+=c[y];
            y++;
        }
        else if(s1>sum)
        {
            s1-=c[x];
            x++;
        }
        else
        {
            break;
        }
    }
    s1=c[y];
    z=y+1;
    for(int i=0; i<n;i++)
    {
        if(s1==sum)
        {
            break;
        }
        else
        {
            s1+=c[z];
            z++;
        }
    }
    cout << "0\n";
    cout<< 1 << " " << 2 << " " << 3;

}